function [I,stimaerrore,x] = trapezi(func,a,b,tol,varargin)
if (nargin == 4)
  n = 2;
else
  n = varargin{1};
end
h = (b-a)/(n-1);
x = linspace(a,b,n)';
w = h/2*[1,2*ones(1,n-2),1];
Ih = w*feval(func,x);
w = h*ones(1,n-1);
Ih2 = (Ih+w*feval(func,x(1:n-1)+h/2))/2;
I = Ih2;
stimaerrore = abs(Ih2-Ih)/2;
x = linspace(a,b,2*n-1);
if (stimaerrore > tol)
  warning('Impossibile raggiungere la tolleranza richiesta')
  warning('con il numero di nodi di quadratura consentito.')
end
